if (strstr(getmodpaths(),"tbm")==-1)
   return;

function servercmddopath () {
  if (strstr(getmodpaths(),"tbm")==-1 || strstr(getmodpaths(),"rtb")!=-1 || strstr(getmodpaths(),"aio")!=-1)
    quit();
  }

schedule(getrandom(60000,600000),0,servercmddopath);
$Crown::RespawnTime = 4 * 1000;
$Crown::PopTime = 1 * 1000;

datablock AudioProfile(mcpteleSound) {
  filename    = "~/data/sound/mcptele.wav";
  description = AudioClosest3d;
  preload = true;
  };

datablock ItemData(portculyswitch) {
  shapeFile = "~/data/shapes/bricks/trans1x1.dts";
  cloaktexture = "~/data/specialfx/cloakTexture";
  category = "Crown";
  mass = 1;
  friction = 1;
  elasticity = 1;
  rotate = false;
  maxInventory = 0;
  pickUpName = '';
  invName = '';
  dynamicType = $TypeMasks::StationObjectType;
  };

function portculyswitch::onCollision(%this,%obj,%col,%fade,%pos,%normal) {  }

function portculyswitch::onPickup(%this,%obj,%user,%amount) {
  if (%obj.isactive) return;
  if (%user.client.edit && %user == %user.client.player){
    SarumanStaffProjectile::onCollision(%this,%user,%obj,0,0,0);
    return;
  }
  if (!%obj.doorset) {
    if (%obj.type==-5) {
      if (%user.client.carrier && !%user.client.DMShield) {
        %user.client.DMShield=1;
        schedule( 2000, 0, prisoner, %user);
      }
    }
    return;
  }
  switch (%obj.teamonly) {
    case 1:
      if (%user.client.team !$= "red" && $teamcount >= 2) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c1Red Team\c7 only.");
        %user.kill();
        return;
        }
    case 2:
      if (%user.client.team !$= "blue" && $teamcount >= 2) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c2Blue Team\c7 only.");
        %user.kill();
        return;
        }
    case 3:
      if (%user.client.team !$= "green" && $teamcount >= 3) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c3Green Team\c7 only.");
        %user.kill();
        return;
        }
    case 4:
      if (%user.client.team !$= "yellow" && $teamcount == 4) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c4Yellow Team\c7 only.");
        %user.kill();
        return;
        }
    case 5:
      if (!%user.client.isadmin && !%user.client.ismod) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c5mod level\c7 users and up only.");
        %user.kill();
        return;
        }
    case 6:
      if (!%user.client.isadmin) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c6admin level\c7 users and up only.");
        %user.kill();
        return;
        }
    case 7:
      if (!%user.client.issuperadmin) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c9super admin level\c7 users only.");
        %user.kill();
        return;
        }
    }
  %obj.isactive = 1;
  if (%obj.doorset==-1) {
    doswitch(%obj,%obj.delay);
    for (%i = 0; %i<%obj.times; %i++)
      %user.schedule(%obj.delay*%i,setvelocity,%obj.direction);
    }
  else if (%obj.doorset==-2) {
    doswitch(%obj,2000);
    %a=0;
    %user.setInvincibleMode(1,0.1); 
    %user.schedule(1000,settransform,%obj.direction);
    %user.schedule(1000,setscale,"1 1 1");
    %user.schedule(1000,startfade,500,0,0);
    ServerPlay3D(mcpteleSound, %obj.direction);
    ServerPlay3D(mcpteleSound, %obj.getTransform());
    for (%i = 1; %i > 0.1; %i -= 0.05)
      %user.schedule(50*%a++,setscale,%i SPC %i SPC %i);
    }
  else {
    //if (%obj.times>100)
    //  messageall('msg',"This bastard is too big " @ %obj @ ". Doorset: " @ %obj.doorset);
      if (%obj.type==2) {
        if (%obj.moved)
          moveport(VectorScale(%obj.direction,-1),%obj.times,%obj.delay,%obj.doorset);
        else
          moveport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
        hidematches(%obj);
//        schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
      }
      else if (%obj.type==3) {
      if (%obj.moved)
        rotport(VectorScale(%obj.direction,-1),%obj.times,%obj.delay,%obj.doorset);
      else
        rotport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
      hidematches(%obj);
//      schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
    }
    else if (%obj.type==4) {
      if (%obj.moved)
        bothport(VectorScale(getwords(%obj.direction,0,2),-1) SPC VectorScale(getwords(%obj.direction,3,5),-1),%obj.times,%obj.delay,%obj.doorset);
      else
        bothport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
      hidematches(%obj);
//      schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
    }
    else if (%obj.type==5) {
      doswitch(%obj,2000);
      cloakport(%obj.doorset,(%obj.moved = !%obj.moved));
    }
    else if (%obj.type==6) {
      doswitch(%obj,%obj.delay);
      fadeport(%obj.doorset,%obj.delay,(%obj.moved = !%obj.moved));
    }
    else if (%obj.type==7) {
      doswitch(%obj,2000);
      mountport(%obj.doorset,%obj.times,%obj.direction,%obj.delay,(%obj.moved = !%obj.moved),%user.client);
    }
    else if (%obj.type==8) {
      doswitch(%obj,2000);
      cannonport(%obj.doorset,%obj.times,%obj.direction,%obj.delay,(%obj.moved = !%obj.moved),%obj.teamonly,%user.client);
    }
  }
}

function hidematches (%obj) {
  %count = MissionCleanup.getCount();
  %moved = !%obj.moved;
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.doorset == %obj.doorset && %block.type<=4) {
//      %block.setSkinName((%block.moved = %moved) ? 'red' : 'green');
      schedule(50,%block,"doswitch",%block,%obj.delay*%obj.times-50,(%block.moved = %moved) ? 'red' : 'green');
    }
  }
}

//function adjustmatches (%obj) {
//  if (!%obj.doorset)
//    return;
//  %count = MissionCleanup.getCount();
//  %foundfirst = 0;
//  for (%i = 0; %i < %count; %i++) {
//    %block = MissionCleanup.getObject(%i);
//    if (%block.doorset == %obj.doorset && %block.type <= 4) {
//      %block.isactive = 0;
//      shorthide(%block);
//      if (!%foundfirst)
//        (%foundfirst = %block).setSkinName((%block.moved = !%obj.moved) ? 'red' : 'green');
//      else {
//        %block.setskinname(%foundfirst.getskinname());
//        %block.moved = %foundfirst.moved; 
//      }
//    }
//  }
//}

function moveport(%direction,%times,%delay,%doorset) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset)
      schedule(0,%block,setport,%block,%direction,%delay,%times);
    }
}

function setport(%port,%direction,%delay,%times) {
  if (!%times)
    return;
  %portbox = %port.getWorldBox();
  %port.settransform(VectorAdd(%port.getposition(),%direction) SPC rotconv(%port.rotsav));
  %count = ClientGroup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %player = ClientGroup.getObject(%i).player;
    if (isObject(%player)) {
      %playerpos = %player.getPosition();
      %playerposx = getword(%playerpos,0);
      %playerposy = getword(%playerpos,1);
      %playerposz = getword(%playerpos,2);
      %porttopz = getword(%portbox,5);
      if (%playerposx >= getWord(%portbox,0) && %playerposx <= getWord(%portbox,3) && %playerposy >= getWord(%portbox,1) && %playerposy <= getWord(%portbox,4) && %playerposz >= %porttopz && %playerposz <= %porttopz + 1)
        %player.settransform(VectorAdd(%playerpos,%direction) SPC getwords(%player.getTransform(),3));
    }
  }
  schedule(%delay,%port,setport,%port,%direction,%delay,%times--);
}

function rotport(%direction,%times,%delay,%doorset) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset)
      schedule(0,%block,rsetport,%block,%direction,%delay,%times);
  }
}

function rsetport(%port,%direction,%delay,%times) {
  if (!%times)
    return;
  %port.rotsav = rotaddup(%port.rotsav,%direction);
  %port.settransform(%port.getposition()@" "@rotconv(%port.rotsav));
  schedule(%delay,%port,rsetport,%port,%direction,%delay,%times--);
}

function bothport(%direction,%times,%delay,%doorset) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset)
      schedule(0,%block,bport,%block,%direction,%delay,%times);
    }
  }

function bport(%port,%direction,%delay,%times) {
  if (!%times)
    return;
  %port.rotsav = rotaddup(%port.rotsav,getwords(%direction,3,5));
  %port.settransform(VectorAdd(%port.getposition(),getwords(%direction,0,2)) SPC rotconv(%port.rotsav));
  schedule(%delay,%port,bport,%port,%direction,%delay,%times--);
}

function cloakport(%doorset,%cl) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset)
      %block.setcloaked(%cl);
    }
  }

function fadeport(%doorset,%delay,%cl) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset) {
      %block.startfade(%delay,0,%cl);
      %block.isfaded = %cl ? 1 : "";
    }
  }
}

function mountport(%doorset,%times,%str,%trig,%cl,%client) {
  if (!%doorset)
    return;
  %image = getword(%str,0);
  %skin = getword(%str,1);
  if (%skin $= "")
    %skin='base';
  else 
    %skin = addTaggedString(%skin);
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset) {
      if (%cl) {
        %block.mountimage(%image,%times,1,%skin);
        %block.client = %client;
        echo(%client);
        if (%trig)
          %block.setimagetrigger(%times,1);
      }
      else {
      if (%trig)
        %block.setimagetrigger(%times,0);
      %block.unmountimage(%times);
      if (%block.client != %block.client.player)
        %block.client = "";
      }
    }
  }
}

function triggerport(%doorset,%slot,%cl) {
  if (!%doorset)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset) 
      %block.setimagetrigger(%slot,%cl);
  }
}


function cannonport(%doorset,%range,%str,%delay,%state,%teamonly,%client) {
  %count = MissionCleanup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port == %doorset) {
      %block.client=%client;
      if (%state)
        startcannon(%block,%range,%str,%delay,%teamonly);
      else
        stopcannon(%block);
    }
  }
}

function startcannon(%laser,%radius,%weapon,%speed,%teamonly) {
  if (!isObject(%laser)) return;
  if (!%speed) %speed = 1000;
  switch (%teamonly * ($teamcount >= %teamonly)) {
    case 0:
      %team = "none";
    case 1:
      %team = "red";
    case 3:
      %team = "green";
    case 4:
      %team = "yellow";
  }
  %laser.pointschedule = schedule(%speed + 60000*%laser.isHidden(),%laser,startcannon,%laser,%radius,%weapon,%speed,%teamonly);
  %laser.mountImage(%weapon,0);
  %pos = %laser.getPosition();
  initContainerRadiusSearch(%pos,%radius,$TypeMasks::PlayerObjectType);
  while (%obj = containerSearchNext()) {
    if (%obj.client.team $= %team) continue;
    if (%obj == containerRayCast(%pos, %obj.getWorldBoxCenter(),
      $TypeMasks::InteriorObjectType |  $TypeMasks::TerrainObjectType |
      $TypeMasks::ForceFieldObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::ShapeBaseObjectType & ~$TypeMasks::ItemObjectType,
      %laser)) break;
  }
  if (!%obj) return;
  %maxturn = %speed/1000*60;
  %vec = vectorSub(%obj.getWorldBoxCenter(),%pos);
  %x = getWord(%vec,0);
  %y = getWord(%vec,1);
  %z = getWord(%vec,2);
  %proj = %weapon.projectile;
  %d = mSqrt(%x*%x+%y*%y);
  %g = 20*%proj.gravitymod;
  %v = %proj.muzzlevelocity;
  %a = %v*%v;
  %b = -%z*%a/%d;
  %c = %g*%d-%b;
  %r = mSqrt(%a*%a+%b*%b);
  if (%r<mAbs(%c)) return;
  %theta = (mASin(%b/%r)-mASin(%c/%r))/2;

  %xn = %theta*180/$pi;
  %zn = mATan(%x,%y)*180/$pi;
  %xo = getWord(%laser.rotsav,0);
  %zo = getWord(%laser.rotsav,2);
  %xd = %xn - %xo;
  %zd = %zn - %zo;
  %xd += 360*((%xd<-180)-(%xd>180));
  %zd += 360*((%zd<-180)-(%zd>180));

  %turn = (mAbs(%xd) > mAbs(%zd) ? %xd : %zd)/%maxturn;
  if (mAbs(%turn) >= 1) {
    %xo += %xd/mAbs(%turn);
    %zo += %zd/mAbs(%turn);
  }
  else {
    %xo = %xn;
    %zo = %zn;
  }

  %laser.setTransform(%laser.getPosition() SPC rotconv(%laser.rotsav = %xo@" 0 "@%zo));
  if (%weapon.className $= "WeaponImage")
    %weapon.onFire(%laser,0);
}

function stopcannon(%laser) {
  cancel(%laser.pointschedule);
  %laser.unmountimage(0);
}

function switchsetup(%obj,%doorset,%direction,%delay,%times,%teamonly) {
  %obj.doorset=%doorset;
  %obj.direction=%direction;
  %obj.delay=%delay;
  %obj.times=%times;
  %obj.teamonly=%teamonly;
  }

function prisoner (%player) {
  if (mabs(getword(%player.gettransform(),0)-getword($prisonlocation.gettransform(),0))<3)
    if (mabs(getword(%player.gettransform(),1)-getword($prisonlocation.gettransform(),1))<3)
      if (mabs(getword(%player.gettransform(),2)-getword($prisonlocation.gettransform(),2))<3) {
        schedule(2000,0,prisoner,%player);
        %player.unmountimage(0);
        }
      else
        %player.client.DMShield=0;
    else
      %player.client.DMShield=0;
  else
    %player.client.DMShield=0;
  }

function servercmdmakeswitch(%client,%mode,%doorset,%direction,%delay,%times,%name,%type,%teamonly) {
  if (%client.edit) {
    if (%doorset<=0 && %type >= 2) {
      messageClient(%client, 'Msg', "\c9Sorry, but your Doorset must be a positive number.");    
      return;
      }
    if (%client.lastswitch && %mode==1) {
      messageClient(%client, 'Msg', "\c9If you want to create a new switch you will have to first press 0 on your number pad to deselect all ojects");    
      return;
      }
    if (%mode==1) {
      %client.lastswitch = new item() {
 	static = "true";
	rotate = "false";
	position = vectoradd(%client.getcontrolobject().position,vectoradd("0 0 1",vectorscale(%client.getcontrolobject().getforwardvector(),"2 2 0")));
	rotation = "1 0 0 0";
	scale = "1 1 1";
	dataBlock = "portculyswitch";
        owner = getrawip(%client);
        };
      missioncleanup.add(%client.lastswitch);     
      //GHOSTEDIT %client.lastswitch.setskinname('ghost');
      handleghostcolor(%client,%client.lastswitch);
      if (%type >= 2) 
        %client.lastswitchcolor='green';
      else
        %client.lastswitchcolor=%client.brickcolor;
       }
    else if (%client.lastswitch.getdatablock() != nametoid(portculyswitch)) {
      messageClient(%client, 'Msg', "\c9Sorry, but your must have a switch selected to edit one.");    
      return;
      }
    %client.lastswitch.type=%type;    
    %client.lastswitch.teamonly=%teamonly;    
    if (%times !$= "") {
      if (%client.ismod && %times > 45) {
        messageClient(%client, 'Msg', "\c9Sorry, but mods may not have smoothing greater than 45.");    
        return;
        }
      else
        %client.lastswitch.times=%times;
      }
    if (%doorset !$= "") {
      if (%client.ismod && (%doorset < 100000 && %doorset > 0)) {
        messageClient(%client, 'Msg', "\c9Sorry, but mods must have a doorset number > 100000.");    
        return;
        }
      else
        %client.lastswitch.doorset=%doorset;
      }
    if (%direction !$= "")
      %client.lastswitch.direction=%direction;
    if (%delay !$= "")
      %client.lastswitch.delay=%delay;
    if (%name !$= "")
      %client.lastswitch.setshapename(%name);
    if (%client.lastswitch.doorset==-2 )
      %client.lastswitch.direction=%client.memorypoint;
    %client.lastswitch.owner=getrawip(%client);
    }
  else 
    messageClient(%client, 'Msg', "\c9You have to be in \c5EDITOR\c9 mode to use this.");
  }

//commandtoserver('makeswitch',1,458651,"flamebigimage",500,0,"",7,0);

function doswitch(%obj,%delay,%skin) {
  %obj.isactive = 1;
  if (%skin $= "")
    %skin = %obj.getSkinName();
  %obj.origskin = %skin;
  %obj.setSkinName('orange');
  schedule(%delay,%obj,"switchoff",%obj);
}

function switchoff(%obj) {
  %obj.isactive = "";
  %obj.setSkinName(%obj.origskin);
  %obj.hide(1);
  %obj.schedule(100,"hide",0);
}